//+------------------------------------------------------------------+
//|                                        TriangularMA centered.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers    3
#property indicator_color1     White
#property indicator_color2     Red
#property indicator_color3     LimeGreen


//
//
//
//
//

extern int    HalfLength       = 59;
extern int    Price            = PRICE_CLOSE;
extern int    TMA_Shift        = 0;
extern int    adrperiod        = 59;
extern double adrmultiplier    = 1.0;

extern color  color_Mray       = White;
extern int    width_Mray       = 1;
extern int    id_of_Mray       = 1;
extern int    Middleray_style  = STYLE_DASH;

extern color  color_Uray       = Red;
extern int    width_Uray       = 1;
extern int    id_of_Uray       = 2;
extern int    Upperray_style   = STYLE_DASH;

extern color  color_Lray       = LimeGreen;
extern int    width_Lray       = 1;
extern int    id_of_Lray       = 3;
extern int    Lowerray_style   = STYLE_DASH; 
  
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsOnHighLow  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;


//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
string MRay;
string URay;
string LRay;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   HalfLength=MathMax(HalfLength,1);
         SetIndexStyle(0,DRAW_LINE);
         SetIndexStyle(1,DRAW_LINE);
         SetIndexStyle(2,DRAW_LINE);
         SetIndexShift(0,TMA_Shift);
         SetIndexShift(1,TMA_Shift);
         SetIndexShift(2,TMA_Shift);
         SetIndexDrawBegin(0,HalfLength);
         SetIndexDrawBegin(1,HalfLength);
         SetIndexDrawBegin(2,HalfLength);
   MRay  = StringConcatenate("MiddleRay",id_of_Mray);
   URay  = StringConcatenate("UpperRay" ,id_of_Uray);
   LRay  = StringConcatenate("LowerRay" ,id_of_Lray);
   CreateMRay();
   CreateURay();
   CreateLRay();
   
   return(0);
}

int deinit()
  {
   ObjectDelete(MRay);
   ObjectDelete(URay);
   ObjectDelete(LRay);
   
   return(0);
  }




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{

   RefreshRates();
   CreateMRay();
   CreateURay();
   CreateLRay();
   if (ObjectFind(MRay)==-1) CreateMRay();
   ObjectSet(MRay,OBJPROP_TIME1,Time[1+(-TMA_Shift)]);
   ObjectSet(MRay,OBJPROP_PRICE1,buffer1[1]);
   ObjectSet(MRay,OBJPROP_TIME2,Time[0+(-TMA_Shift)]);
   ObjectSet(MRay,OBJPROP_PRICE2,buffer1[0]);
   ObjectSet(MRay,OBJPROP_TIME3,Time[0+(-TMA_Shift)]);
   ObjectSet(MRay,OBJPROP_PRICE3,buffer1[0]);  
   } 
   void CreateMRay()
   {
   SetIndexBuffer(0,buffer1);
   ObjectCreate(MRay,OBJ_TREND,0,0,0,0,0);
   ObjectSet(MRay,OBJPROP_RAY,true);
   ObjectSet(MRay,OBJPROP_COLOR,color_Mray);
   ObjectSet(MRay,OBJPROP_WIDTH,width_Mray);
   ObjectSet(MRay,OBJPROP_STYLE,Middleray_style);

   if (ObjectFind(URay)==-1) CreateURay();
   ObjectSet(URay,OBJPROP_TIME1,Time[1+(-TMA_Shift)]);
   ObjectSet(URay,OBJPROP_PRICE1,buffer2[1]);
   ObjectSet(URay,OBJPROP_TIME2,Time[0+(-TMA_Shift)]);
   ObjectSet(URay,OBJPROP_PRICE2,buffer2[0]);
   ObjectSet(URay,OBJPROP_TIME3,Time[0+(-TMA_Shift)]);
   ObjectSet(URay,OBJPROP_PRICE3,buffer2[0]);  
   } 
   void CreateURay()
   {
   SetIndexBuffer(1,buffer2);
   ObjectCreate(URay,OBJ_TREND,0,0,0,0,0);
   ObjectSet(URay,OBJPROP_RAY,true);
   ObjectSet(URay,OBJPROP_COLOR,color_Uray);
   ObjectSet(URay,OBJPROP_WIDTH,width_Uray);
   ObjectSet(URay,OBJPROP_STYLE,Upperray_style);
   
   if (ObjectFind(LRay)==-1) CreateLRay();
   ObjectSet(LRay,OBJPROP_TIME1,Time[1+(-TMA_Shift)]);
   ObjectSet(LRay,OBJPROP_PRICE1,buffer3[1]);
   ObjectSet(LRay,OBJPROP_TIME2,Time[0+(-TMA_Shift)]);
   ObjectSet(LRay,OBJPROP_PRICE2,buffer3[0]);
   ObjectSet(LRay,OBJPROP_TIME3,Time[0+(-TMA_Shift)]);
   ObjectSet(LRay,OBJPROP_PRICE3,buffer3[0]); 
   }
   void CreateLRay()
   {
   SetIndexBuffer(2,buffer3);
   ObjectCreate(LRay,OBJ_TREND,0,0,0,0,0);
   ObjectSet(LRay,OBJPROP_RAY,true);
   ObjectSet(LRay,OBJPROP_COLOR,color_Lray);
   ObjectSet(LRay,OBJPROP_WIDTH,width_Lray);
   ObjectSet(LRay,OBJPROP_STYLE,Lowerray_style);
   
   
   int counted_bars=IndicatorCounted();
   int i,j,k,x,limit;
   double range;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars+HalfLength);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      double sum  = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sumw = (HalfLength+1);
      for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
      {
         sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
         sumw += k;

         if (j<=i)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
            sumw += k;
         }
      }

      //
      //
      //
      //
      //
        RefreshRates();
        for(x=1;x<=adrperiod;x++) {
        range+=iHigh(Symbol(),PERIOD_D1,x+iBarShift(Symbol(),PERIOD_D1,Time[i]))-iLow(Symbol(),PERIOD_D1,x+iBarShift(Symbol(),PERIOD_D1,Time[i])); }
        range=range/adrperiod*adrmultiplier;
        buffer1[i] = sum/sumw;
        buffer2[i] = buffer1[i]+range;
        buffer3[i] = buffer1[i]-range;
   }
   
   //
   //
   //
   //
   //

   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      if (alertsOnHighLow)       
      {
         if (High[forBar]>buffer2[forBar] && High[forBar+1]<buffer2[forBar+1]) doAlert("high penetrated upper bar");
         if (Low[forBar] <buffer3[forBar] && Low[forBar+1] >buffer3[forBar+1]) doAlert("low penetrated lower bar");
      }
      else
      {
         if (Close[forBar]>buffer2[forBar] && Close[forBar+1]<buffer2[forBar+1]) doAlert("close penetrated upper bar");
         if (Close[forBar]<buffer3[forBar] && Close[forBar+1]>buffer3[forBar+1]) doAlert("close penetrated lower bar");
      }
   }   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="";
   static datetime previousTime;
   string message;

   //
   //
   //
   //
   //
   
   if (previousAlert!=doWhat || previousTime!=Time[0]) 
   {
      previousAlert = doWhat;
      previousTime  = Time[0];

      message= StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," THA : ",doWhat);
         if (alertsMessage) Alert(message);
         if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TMA "),message);
         if (alertsSound)   PlaySound("alert2.wav");
    }
}